﻿Type=StaticCode
Version=4.3
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
'Code module
'Subs In this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public Result(3) As String
	
End Sub

Public Sub getsql_salesmanager As String()
    'Result(0) -> SQL For data
    'Result(1) -> SQL For totals
    'Result(2) -> columns To align
    Result(0) = "SELECT SalesManagerCode AS 'Sales Manager Number', SalesManagerName AS 'Sales Manager Name', IFNULL(SUM(TurnoverEuro),0) AS 'Turnover', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & Main.fy & "' GROUP BY SalesManagerCode, SalesManagerName ORDER BY SalesManagerName"
	Result(1) = "SELECT IFNULL(SUM(TurnoverEuro),0) AS 'Turnover', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & Main.fy & "'"
    Result(2) = "2;3"
	Return Result
End Sub

Public Sub getsql_customer(overview As Int, ag As String) As String()
    'md Yes/No monthly details
    'overview: artgrp=0, totals=1, Standard Margin=2, planning=3, outlook=4
    'result(0) -> sql for data
    'result(1) -> sql for totals
    'result(2) -> columns to align
    Dim cn As String = Main.customerspntext
	Dim fy0, fy1, fy2 As Int
	fy0 = Main.fy
	fy1 = fy0 - 1
	fy2 = fy1 - 1
	Dim fm, lm As String 
	DateTime.DateFormat = "yyyy-MM-dd"
	fm = Main.settings_firstmonth
    lm = Main.settings_lastmonth
    Dim epf As String
	epf = (365 / DateDiff(fm, lm))
    Select Case overview
        Case 0 'artgrp
                Result(0) = "SELECT ArticleCode AS 'Article Number', ArticleName AS 'Article Name', IFNULL(SUM(Qty),0) AS 'Quantity', IFNULL(SUM(TurnoverEuro),0) AS 'Turnover', (CASE WHEN SUM(Qty) = 0 THEN '0' ELSE  IFNULL(SUM(TurnoverEuro),0)/SUM(Qty) END) AS 'Turnover/Qty', IFNULL(SUM(gmEuro),0) AS 'Standard Margin',IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) AS 'Standard Margin (%)', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND CustomerCode = '" & cn & "' AND ArtGrpCode = '" & ag & "' GROUP BY ArticleCode, ArticleName HAVING (IFNULL(SUM(Qty),0) <> 0  OR IFNULL(SUM(TurnoverEuro),0) <> 0  OR IFNULL(SUM(ScheduledOnHandEuro),0) <> 0) ORDER BY ArticleCode"
                Result(1) = "SELECT IFNULL(SUM(Qty),0), IFNULL(SUM(TurnoverEuro),0), IFNULL(SUM(TurnoverEuro) / NULLIF(SUM(Qty),0),0) AS 'Turnover/Qty', IFNULL(SUM(gmEuro),0) AS 'Standard Margin',IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) AS 'Standard Margin (%)', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND CustomerCode = '" & cn & "' AND ArtGrpCode = '" & ag & "'"
                Result(2) = "2;3;4;5;6;7"
        Case 1 'totals
                Result(0) = "SELECT ArticleCode AS 'Article Number', ArticleName AS 'Article Name', IFNULL(SUM(Qty),0) AS 'Quantity', IFNULL(SUM(TurnoverEuro),0) AS 'Turnover', IFNULL(SUM(TurnoverEuro) / NULLIF(SUM(Qty),0),0) AS 'Turnover/Qty', IFNULL(SUM(gmEuro),0) AS 'Standard Margin',IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) AS 'Standard Margin (%)', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND CustomerCode = '" & cn & "' GROUP BY ArticleCode, ArticleName HAVING (IFNULL(SUM(Qty),0) <> 0  OR IFNULL(SUM(TurnoverEuro),0) <> 0  OR IFNULL(SUM(ScheduledOnHandEuro),0) <> 0) ORDER BY ArticleCode"
                Result(1) = "SELECT IFNULL(SUM(Qty),0), IFNULL(SUM(TurnoverEuro),0), IFNULL(SUM(TurnoverEuro) / NULLIF(SUM(Qty),0),0) AS 'Turnover/Qty', IFNULL(SUM(gmEuro),0) AS 'Standard Margin',IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) AS 'Standard Margin (%)', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND CustomerCode = '" & cn & "'"
                Result(2) = "2;3;4;5;6;7"
        Case 2 'gm
	            Result(0) = "SELECT ArticleCode AS 'Article Number', ArticleName AS 'Article Name', IFNULL(SUM(TurnoverEuro),0) AS 'Turnover', IFNULL(SUM(gmEuro),0) AS 'Standard Margin', IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) AS 'Standard Margin (%)' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND CustomerCode = '" & cn & "' GROUP BY ArticleCode, ArticleName HAVING (IFNULL(SUM(TurnoverEuro),0) <> 0  OR IFNULL(SUM(gmEuro),0) <> 0) ORDER BY ArticleCode"
	            Result(1) = "SELECT IFNULL(SUM(TurnoverEuro),0), IFNULL(SUM(gmEuro),0), IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND CustomerCode = '" & cn & "'"
	            Result(2) = "2;3;4"
        Case 3 'planning
                Result(0) = "SELECT ArtGrpCode AS 'Article Group Number', ArtGrpName AS 'Article Group Name', IFNULL(SUM(CASE WHEN FiscalYear = 'V9/" & fy0 & "' THEN PlanningEuro END),0)  AS 'Planning', SUM(CASE WHEN (FiscalYear = 'V9/" & fy0 & "' AND MonthYear <= '" & lm & "') THEN " & epf & " * TurnoverEuro ELSE '0' END) AS 'Extrapolation', SUM(CASE WHEN FiscalYear = 'V9/" & fy0 & "' THEN TurnoverEuro ELSE '0' END) AS 'Turnover " & fy0 & "', SUM(CASE WHEN FiscalYear = 'V9/" & fy1 & "' THEN TurnoverEuro ELSE '0' END) AS 'Turnover " & fy1 & "', SUM(CASE WHEN FiscalYear = 'V9/" & fy2 & "' THEN TurnoverEuro ELSE '0' END) AS 'Turnover " & fy2 & "' FROM " & Main.TABLENAME0 & " WHERE CustomerCode = '" & cn & "' GROUP BY ArtGrpCode, ArtGrpName ORDER BY SUM(CASE WHEN FiscalYear = 'V9/" & fy0 & "' THEN TurnoverEuro ELSE '0' END) DESC"
                Result(1) = "SELECT IFNULL(SUM(CASE WHEN FiscalYear = 'V9/" & fy0 & "' THEN PlanningEuro END),0)  AS 'Planning', SUM(CASE WHEN (FiscalYear = 'V9/" & fy0 & "' AND MonthYear <= '" & lm & "') THEN " & epf & " * TurnoverEuro ELSE '0' END)  AS 'Extrapolation', SUM(CASE WHEN FiscalYear = 'V9/" & fy0 & "' THEN TurnoverEuro ELSE '0' END) AS 'Turnover " & fy0 & "', SUM(CASE WHEN FiscalYear = 'V9/" & fy1 & "' THEN TurnoverEuro ELSE '0' END) AS 'Turnover " & fy1 & "', SUM(CASE WHEN FiscalYear = 'V9/" & fy2 & "' THEN TurnoverEuro ELSE '0' END) AS 'Turnover " & fy2 & "' FROM " & Main.TABLENAME0 & " WHERE CustomerCode = '" & cn & "'"
                Result(2) = "2;3;4;5;6"
        Case 4 'outlook
                Result(0) = "SELECT ArticleCode AS 'Article Number', ArticleName AS 'Article Name', IFNULL(SUM(TurnoverEuro),0) AS 'Turnover', SUM(CASE WHEN (FiscalYear = 'V9/" & fy0 & "' AND MonthYear <= '" & lm & "') THEN " & epf & " * TurnoverEuro ELSE '0' END) AS 'Extrapolation', IFNULL(SUM(IncomingEuro),0) AS 'Incoming orders', (CASE WHEN SUM(TurnoverEuro) <> 0 THEN SUM(IncomingEuro) / SUM(TurnoverEuro) ELSE '0' END) AS 'Book to bill', IFNULL(SUM(ScheduledOnHandEuro),0) AS 'Scheduled on hand', IFNULL(SUM(GMEuro),0) AS 'Standard Margin', IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) AS 'Standard Margin (%)' FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND  CustomerCode = '" & cn & "' GROUP BY ArticleCode, ArticleName HAVING (IFNULL(SUM(TurnoverEuro),0) <> 0  OR IFNULL(SUM(GMEuro),0) <> 0) ORDER BY ArticleCode"
                Result(1) = "SELECT IFNULL(SUM(TurnoverEuro),0), SUM(CASE WHEN (FiscalYear = 'V9/" & fy0 & "' AND MonthYear <= '" & lm & "') THEN " & epf & " * TurnoverEuro ELSE '0' END), IFNULL(SUM(IncomingEuro),0), (CASE WHEN SUM(TurnoverEuro) <> 0 THEN SUM(IncomingEuro) / SUM(TurnoverEuro) ELSE '0' END), IFNULL(SUM(ScheduledOnHandEuro),0), IFNULL(SUM(GMEuro),0), IFNULL(100*SUM(GMEuro)/NULLIF(SUM(TurnoverEuro),0),0) FROM " & Main.TABLENAME0 & " WHERE FiscalYear = 'V9/" & fy0 & "' AND  CustomerCode = '" & cn & "'"
                Result(2) = "2;3;4;5;6;7;8"
    End Select
    Return Result
End Sub

Sub DateDiff(Date1 As String, Date2 As String)As Long
	Dim tks As Long
	tks = DateTime.DateParse(Date1) - DateTime.DateParse(Date2)
	Return tks / DateTime.TicksPerDay
End Sub
